
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

int LZ_Compress(unsigned char *in, unsigned char *out, unsigned int insize);

int main(int argc, char *argv[])
{
   int in, out, size;
   struct stat buf;
   unsigned char *uncompressed, *compressed;
   
   if (argc == 3) {
	   in = open(argv[1], O_RDONLY);
	   out = creat(argv[2], 0600);
	   fstat(in, &buf);
	   uncompressed = malloc(buf.st_size);
	   read(in, uncompressed, buf.st_size);
	   close(in);
	   compressed = malloc(buf.st_size*2);
           size = LZ_Compress(uncompressed, compressed, buf.st_size);
	   write(out, compressed, size);
	   close(out);
	   free(compressed);
	   free(uncompressed);
	   return 0;
   }
   printf("Usage: %s file.bin file.lz77\n", argv[0]);
   return 1;
}
